> For the complete documentation index, see [llms.txt](https://docs.sperax.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.sperax.io/sperax-farms-protocol/technical-documents/smart-contracts/features/claimablefee.md).

# ClaimableFee

[Git Source](https://github.com/Sperax/Demeter-Protocol/blob/cc93b9106874316d6dd016cdace652e2ca4ef8e1/contracts/features/ClaimableFee.sol)

**Inherits:** Farm

**Author:** Sperax Foundation.

Farms build for pairs/ pools in which fee can be claimed can extend and override \_claimPoolFee function of this contract.

## Functions

### claimPoolFee

A function to claim the pool fee earned by lp.

*Only the deposit owner can call this function.*

```solidity
function claimPoolFee(uint256 _depositId) external nonReentrant;
```

**Parameters**

| Name         | Type      | Description        |
| ------------ | --------- | ------------------ |
| `_depositId` | `uint256` | ID of the deposit. |

### \_claimPoolFee

Claim pool fee internal logic to be implemented by child farm contract.

*Just override this function and write the logic to claim fee, validation and other checks are handled in `claimPoolFee`.*

```solidity
function _claimPoolFee(uint256 _depositId)
    internal
    virtual
    returns (uint256 tokenId, uint256 amt0Recv, uint256 amt1Recv);
```

**Parameters**

| Name         | Type      | Description                            |
| ------------ | --------- | -------------------------------------- |
| `_depositId` | `uint256` | Deposit ID of the deposit in the farm. |

**Returns**

| Name       | Type      | Description                                                               |
| ---------- | --------- | ------------------------------------------------------------------------- |
| `tokenId`  | `uint256` | Token ID of the deposit for E721 farms, for other farms return depositId. |
| `amt0Recv` | `uint256` | Amount 0 received as fee.                                                 |
| `amt1Recv` | `uint256` | Amount 1 received as fee.                                                 |

## Events

### PoolFeeCollected

```solidity
event PoolFeeCollected(address indexed recipient, uint256 tokenId, uint256 amt0Recv, uint256 amt1Recv);
```

## Errors

### NoFeeToClaim

```solidity
error NoFeeToClaim();
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.sperax.io/sperax-farms-protocol/technical-documents/smart-contracts/features/claimablefee.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
